\name{sbw-package}
\alias{sbw-package}
\alias{sbw}
\docType{package}
\title{
Stable Balancing Weights for Causal Inference and Estimation with Incomplete Data
}
\description{
Finds stable weights, e.g., of minimum variance, that balance the empirical distribution of the observed covariates up to levels prespecified by the user. This method allows the user to directly balance the means of the observed covariates and other features of their marginal and joint distributions such as variances and correlations and also, say, the quantiles of interactions of pairs of observed covariates, thus balancing entire two-way marginals. The dual variables of the covariate balance constraints provide insight into the behavior of the variance of the optimal weights in relation to the level of covariate balance adjustment. The package also contains functions for weight diagnostics.
}
\details{
\tabular{ll}{
Package: \tab sbw\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2016-03-14\cr
License: \tab GPL-2 | GPL-3\cr
}
}
\author{
	Author: Jose R. Zubizarreta <zubizarreta@columbia.edu>, Amine Allouah <mallouah19@gsb.columbia.edu>.

Maintainer: Jose R. Zubizarreta <zubizarreta@columbia.edu>.
}
\references{
	Zubizarreta, J. R., "Stable Weights that Balance Covariates for Causal Inference and Estimation with Incomplete Data," Journal of the American Statistical Association, 110, 910-922.
}